<template>
  <div class="rich_editor">
    <editor-menu-bar :editor="editor">
        <div slot-scope="{ commands, isActive }">
            <button class="menubar__button" :class="{ 'is-active': isActive.bold() }" @click="commands.bold">
                <icon name="bold" />
            </button>
            <button class="menubar__button" :class="{ 'is-active': isActive.italic() }" @click="commands.italic">
                <icon name="italic" />
            </button>
            <button class="menubar__button" :class="{ 'is-active': isActive.strike() }" @click="commands.strike"
            >
                <icon name="strike" />
            </button>

            <button class="menubar__button" :class="{ 'is-active': isActive.underline() }" @click="commands.underline"
            >
                <icon name="underline" />
            </button>
            &nbsp;&nbsp;
            <button class="menubar__button" :class="{ 'is-active': isActive.heading({ level: 1 }) }" @click="commands.heading({ level: 1 })">
                H1
            </button>
            <button class="menubar__button" :class="{ 'is-active': isActive.heading({ level: 2 }) }" @click="commands.heading({ level: 2 })">
                H2
            </button>
            <button class="menubar__button" :class="{ 'is-active': isActive.heading({ level: 3 }) }" @click="commands.heading({ level: 3 })">
                H3
            </button>
            &nbsp;&nbsp;
            <button class="menubar__button" :class="{ 'is-active': isActive.bullet_list() }" @click="commands.bullet_list">
                <icon name="ul" />
            </button>
            <button class="menubar__button" :class="{ 'is-active': isActive.ordered_list() }" @click="commands.ordered_list">
                <icon name="ol" />
            </button>
            &nbsp;&nbsp;
            <button class="menubar__button" :class="{ 'is-active': isActive.blockquote() }" @click="commands.blockquote">
                <icon name="quote" />
            </button>
            <button class="menubar__button" @click="commands.horizontal_rule">
                <icon name="hr" />
            </button>
            <button class="menubar__button" :class="{ 'is-active': isActive.hard_break() }" @click="commands.hard_break">
                Br
            </button>
        </div>
    </editor-menu-bar>
    <editor-content :editor="editor" class="editor-content" />
  </div>
</template>

<script>
import { Editor, EditorContent, EditorMenuBar } from 'tiptap';
import {
    Blockquote,
    Heading,
    OrderedList,
    BulletList,
    ListItem,
    Bold,
    Italic,
    Link,
    Strike,
    Underline,
    HorizontalRule,
    History,
} from 'tiptap-extensions';
import CustomHardBreak from './extensions/CustomHardBreak';
import Icon from './MenuIcon';

export default {
    components: {
        EditorMenuBar,
        EditorContent,
        Icon,
    },
    props: {
        /** current html text */
        value: {
            type: String,
            required: false,
        },
    },
    watch: {
        value(val) {
            // so cursor doesn't jump to start on typing
            if (val !== this.editor.getHTML()) {
                this.editor.setContent(val);
            }
        },
    },
    data() {
        return {
            editor: null,
        };
    },
    mounted() {
        this.editor = new Editor({
            extensions: [
                new Blockquote(),
                new CustomHardBreak(),
                new Heading({ levels: [1, 2, 3] }),
                new BulletList(),
                new OrderedList(),
                new ListItem(),
                new Bold(),
                new Italic(),
                new Link(),
                new Strike(),
                new Underline(),
                new History(),
                new HorizontalRule(),
            ],
            autoFocus: true,
            editorProps: {
                attributes: {
                    class: 'rich_editor__area',
                },
            },
            onUpdate: ({ getHTML }) => {
                let html = getHTML();
                if (html === '<p></p>') {
                    html = '';
                }
                this.$emit('input', html);
            },
        });
        this.editor.setContent(this.value);
    },
    beforeDestroy() {
        this.editor.destroy();
    },
};
</script>

<style lang="stylus" scoped>
@import '../../assets/styles/rich_editor.styl'

.rich_editor
    width: 100%

>>> .rich_editor__area
    outline: 0

.is-active
    background: rgba(0,0,0,.1) !important

.menubar__button
    background: rgba(0,0,0,0)
    border: 0
    color: black
    padding: .5rem .5rem
    margin-right: .2rem
    border-radius: 3px
    cursor: pointer
    width: 3rem
    height: 3rem
    margin-bottom: .6rem

.menubar__button:hover
    background: rgba(0,0,0,.2)

.editor-content
    border-radius: 4px;
    background-color: white
    border: 1px solid $input_border
    width: 100%
    padding: .5rem

.editor-content:hover
    border-color: $input_hover_border

</style>
